\begin{frame}%
  \frametitle{The Gillespie Algorithm}%
  \begin{block}{Reaction--rate equation}%
    \begin{equation}
      \frac{d}{dt} \vec{N} = \mathbf{F}\left(\vec N\right)\cdot \vec N~.
    \end{equation}
    \begin{tabular}[ ]{cl}
      $\vec N = \{N_i\}_{i=1}^L$ & Concentration (abundance) of species $i$ \\
      $\mathbf{F}$   & Transition matrix
    \end{tabular}
  \end{block}
  %
\end{frame}%
%
\begin{frame}%
  \frametitle{The Gillespie Algorithm}%
  \begin{block}{Reaction Master Equation\footfullcite{Gillespie1976}}%
    \begin{align}
      \frac{\partial}{\partial t}P(\{N_i,t\}) &= \sum_{\mu=1}^M \left[P(\{N_i,t\}_{\dagger\mu})b_{\mu} - P(\{N_i,t\})a_{\mu}\right] \\
      &=\sum_{\mu=1}^{M}\left[ B_\mu
      - a_\mu P(\{N_i\}; t)\right]~.
      \label{eqn:chemical_master_equation}
    \end{align}
    \begin{tabular}[ ]{cl}
      $P$ & Probability distribution function \\
      $N_i$ & Concentration (abundance) of species $i$ \\
      $L$   & Number of species \\
      $M$   & Number of reaction channels \\
      $B_\mu dt$   & Probability of ``$\mu$--reaction removed'' state $\{N_i,t\}_{\dagger\mu}$\\
      $a_\mu dt$   & Probability that reaction $\mu$ occurs.
    \end{tabular}
    % See also \fullcite{Roepke2013}
  \end{block}%
\end{frame}%
%
\begin{frame}{Gillespie [1977]}
  \begin{block}{From prob. density $P(\vec N;t)$ to reaction prob. density $P(\tau, \mu)$}
    \begin{center}
      \includegraphics[width=.7\textwidth]{Screenshot_2022-06-17_11-57-27}
    \end{center}
  \end{block}
\end{frame}
%
\begin{frame}%
  \frametitle{The Gillespie Algorithm}%
  %
  \begin{block}{Simulation algorithm\footfullcite{Gillespie1977}}%
    \begin{center}%
    \begin{tikzpicture}[align=left]
      \small
      %
      % Nodes
      %
      \node(start)[base]{%
        \textbf{Input}\\
        $\{N_i\}_{i=1}^L, \{c_\nu\}_{\nu=1}^M, t=0$
      };
      \node(state)[process,
                   below of=start,
                   yshift=-.5cm
                   ]{%
                     \textbf{State at t}\\
                     $\{N_i\}, \{c_\nu\}$
                     };
      \node(propensities)[process, right of=state,
      xshift=4cm]{%
        \textbf{Propensities}\\
        $a_\nu = c_\nu h_{\nu}(\vec N)$\\
        $a_0 = \sum_{\nu}a_\nu$
      };
      \node(random)[process, below of=propensities,
      yshift=-1.5cm
    ]{
        \textbf{Randomization}\\
        $r_1, r_2 \in [0,1]$\\
        $\tau = -\ln(r_1) / a_0$\\
        $\sum_{\nu=1}^{\mu-1}a_\nu \leq r_2\cdot a_0 \leq \sum_{\nu=\mu}^{M} a_\nu$
      };
      \node(propagate)[process, below of=state,
      yshift=-1.5cm
    ]{\textbf{Propagation}\\
        $t\rightarrow t+\tau$\\
        $\left\{ N_i\right\} {\mu\atop\rightarrow} \left\{ N_i\right\} $.
      };
      %\node(switch_t)[switch, below of=state,
      %yshift=-1.5cm
    %]{%
        %$t >= T$ ?
      %};
      %\node(stop)[base, below of=switch_t,
      %yshift=-1cm
      %]{%
        %\textbf{Output}\\
        %$N_i, c_\mu, t=T$
      %};
      %
      % Edges
      %
      \draw[->](start) -- (state);
      \draw[->](state) -- (propensities);
      \draw[->](propensities) -- (random);
      \draw[->](random) -- (propagate);
      \draw[->](propagate) -- (state);
      %\draw[->](switch_t) -- (stop);
      %
      % End
      %
    \end{tikzpicture}%
  \end{center}%
  \vspace*{\fill}
  \end{block}
  %
\end{frame}%
%
% \begin{frame}%
%   \frametitle{The Gillespie Algorithm}%
%   \begin{block}{Some observations}%
%     \begin{itemize}
%       \item Time advances in irregular, unpredictable increments
%       \item Every process is considered individually
%       \item $\tau, \mu$ depend on current state only (Markov chain)
%       \item[$\hookrightarrow$] Cannot parallelize over reactions
%     \end{itemize}%
%   \end{block}%
%   %
% \end{frame}%

